Summary: A library for speech signal processing. 
Name: spLib
Version: 0.9.4
Release: 3
License: distributable
Distribution: (none)
Vendor: (none)
Group: Development/Libraries
Source: %{name}-%{version}-%{release}.tgz
URL: http://www-ie.meijo-u.ac.jp/labs/rj001/spLibs/index.html
BuildRoot: %{_tmppath}/%{name}-%{version}-root
Requires: spBase >= 0.8.21, spAudio >= 0.7.13
BuildRequires: findutils, spBase >= 0.8.21, spAudio >= 0.7.13, fftw-devel
%define __spec_install_post /usr/lib/rpm/brp-compress || :
%define _binaries_in_noarch_packages_terminate_build 0

%description
A library for speech signal processing. This library includes many functions
for signal processing.

%package android
Summary: spLib library for Android development
Group: Development/Libraries
BuildArch: noarch
Requires: spBase-android >= 0.8.21, spAudio-android >= 0.7.13
%description android
This package includes spLib library for Android development.

%package fftplugins
Summary: FFT plugins for spLib
Group: System Environment/Libraries
Requires: fftw
%description fftplugins
This plugin collection includes FFT plugins for spLib that use
great external FFT engines.

%package fftplugins-android
Summary: FFT plugins of spLib for Android development
Group: System Environment/Libraries
BuildArch: noarch
%description fftplugins-android
This package includes FFT plug-ins of spLib for Android development.

%changelog
* Tue Nov 20 2018  Hideki Banno
- Version 0.9.4-3

* Fri Apr 28 2017  Hideki Banno
- Version 0.9.4-2

* Thu Oct 27 2016  Hideki Banno
- Version 0.9.4

* Mon May 16 2016  Hideki Banno
- Version 0.9.3-2

* Tue Dec 22 2015  Hideki Banno
- Version 0.9.3

* Fri Sep 19 2014  Hideki Banno
- Version 0.9.1

* Mon Sep  3 2012  Hideki Banno
- Version 0.9.0

* Thu Nov 27 2008  Hideki Banno
- Version 0.8.9

* Tue Jun 27 2006  Hideki Banno
- Version 0.8.6

* Tue Mar  8 2005  Hideki Banno
- Version 0.8.5

* Sun Jul 11 2004  Hideki Banno
- Version 0.8.4

* Sun Oct  8 2000  Hideki Banno
- Version 0.8.3

* Sun Jun 18 2000  Hideki Banno
- Version 0.8.2

* Fri Aug 27 1999  Hideki Banno
- Version 0.8.1

* Mon Apr 5 1999 Hideki Banno
- 1st release

%prep
%setup -q
%{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_prefix}

%build
%define debug_package %{nil}
cd sp
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} clean
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib}

cd example
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} cleanbin
cp Makefile Makefile.org
cp Makefile.main Makefile.main.org
%{__sed} -e "s|\.\./\.\.|%{_prefix}|" -e "s|= lib|= %{_lib}|" Makefile.org > Makefile
%{__sed} -e "s|\.\./\.\.|%{_prefix}|" -e "s|= lib|= %{_lib}|" Makefile.main.org > Makefile.main
%{__rm} -f Makefile.org Makefile.main.org
%{__rm} -f *.sln *.suo
%{__rm} -f *.make
%{__rm} -f *.bat
%{__rm} -f ffttest*.csv
%{__rm} -f FFTTEST*.txt
%{__rm} -rf plugins*
%{__rm} -rf vc
%{__rm} -rf Debug*
%{__rm} -rf debug*
%{__rm} -rf Release*
%{__rm} -rf release*
%{__rm} -rf x64

mkfiles=`find android -name Android.mk`
for mkfile in ${mkfiles} ; do
    %{__sed} -i \
	-e 's|SP_INCLUDE_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./include|SP_INCLUDE_TOP := /usr/share/sp/include|g' \
	-e 's|SP_BASE_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spBase|SP_BASE_TOP := /usr/share/sp/spBase|g' \
	-e 's|SP_BASE_LIB_LOCAL := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spBase/android/obj/local|SP_BASE_LIB_LOCAL := $(SP_BASE_TOP)/android/obj/local|g' \
	-e 's|SP_AUDIO_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spAudio|SP_AUDIO_TOP := /usr/share/sp/spAudio|g' \
	-e 's|SP_AUDIO_LIB_LOCAL := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./spAudio/android/obj/local|SP_AUDIO_LIB_LOCAL := $(SP_AUDIO_TOP)/android/obj/local|g' \
	-e 's|SP_TOP := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\.|SP_TOP := /usr/share/sp/sp|g' \
	-e 's|SP_LIB_LOCAL := $(LOCAL_PATH)/\.\./\.\./\.\./\.\./\.\./sp/android/obj/local|SP_LIB_LOCAL := $(SP_TOP)/android/obj/local|g' \
	"${mkfile}"
done

cd ..

cd ..

%install
%{__mkdir_p} %{buildroot}%{_datadir}/sp/sp/android/obj
cd sp
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install
%{__make} TOP=%{_prefix} SPLIBDIRNAME=%{_lib} SPDESTROOT=%{buildroot}%{_prefix} install.hdr
cp -r android/obj/local %{buildroot}%{_datadir}/sp/sp/android/obj/
cd ..
%{__strip} --strip-debug %{buildroot}%{_libdir}/lib*.a
if [ -f %{buildroot}%{_libdir}/libsp.linux-glibc.a ]; then
    %{__ln_s} libsp.linux-glibc.a %{buildroot}%{_libdir}/libsp.linux.a
fi

%{__mkdir_p} lib/sp/plugins
%{__mkdir_p} %{buildroot}%{_libdir}/sp/plugins
%{__ln_s} %{_libdir}/libspb.*.a lib/
%{__ln_s} %{_libdir}/libspa.*.a lib/
%{__ln_s} %{_libdir}/sp/{*.cf,*.rules,*.def,Make*} lib/sp/
%{__ln_s} %{_includedir} spBase
cd sp/FFTPlugin
cd oourafft
%{__make} clean
%{__make} 
%{__make} PLUGINDEST=%{buildroot}%{_libdir}/sp/plugins install
%{__mkdir_p} %{buildroot}%{_datadir}/sp/sp/FFTPlugin/oourafft/android
cp -r android/libs %{buildroot}%{_datadir}/sp/sp/FFTPlugin/oourafft/android/
cd ../fftw
%{__make} clean
%{__make} 
%{__make} PLUGINDEST=%{buildroot}%{_libdir}/sp/plugins install
%{__mkdir_p} %{buildroot}%{_datadir}/sp/sp/FFTPlugin/fftw/android
cp -r android/libs %{buildroot}%{_datadir}/sp/sp/FFTPlugin/fftw/android/
cd ../../..
%{__strip} --strip-debug %{buildroot}%{_libdir}/sp/plugins/*.so

%{__mkdir_p} oourafft
cp sp/FFTPlugin/oourafft/fft/readme.txt oourafft

%clean
%{__rm} -rf %{buildroot}

%pre
%post
%preun
%postun

%files 
%defattr(-,root,root)
%doc sp/README* sp/CHANGES* sp/LICENSE*
%doc sp/example
%{_libdir}/*.a
%{_includedir}/sp/*.h

%files android
%defattr(-,root,root)
%dir %{_datadir}/sp/sp
%{_datadir}/sp/sp/android/

%files fftplugins
%defattr(-,root,root)
%doc sp/FFTPlugin/README*
%doc oourafft
%{_libdir}/sp/plugins/*.so

%files fftplugins-android
%defattr(-,root,root)
%dir %{_datadir}/sp/sp
%{_datadir}/sp/sp/FFTPlugin/
